<app-header title="Profil"></app-header>
<ion-content>
    <ion-grid>
        <!-- Title -->
        <ion-row
            *ngIf="!readonly"
            class="ion-justify-content-center ion-padding ion-margin-top"
        >
            <ion-col size="auto" class="ion-no-padding">
                <app-img
                    src="assets/img/kymia.svg"
                    class="block width-26"
                    alt="logo"
                    title="logo"
                    [errorSrc]="cardMedia"
                ></app-img>
            </ion-col>
            <ion-col
                size="auto"
                class="ion-text-center size-24 weight-600 ml-8 ion-no-padding"
            >
                <ion-text color="dove-light"> Mise à jour </ion-text>
            </ion-col>
        </ion-row>

        <form
            class="ion-padding"
            [formGroup]="profilForm"
            name="profilForm"
            novalidate
        >
            <!-- Firstname required -->
            <div
                *ngIf="submit && f.firstname.errors && f.firstname.errors.required"
                class="size-12 ion-text-left ml-34 mt-5"
            >
                <ion-text color="danger">Le prenom est obligatoire</ion-text>
            </div>

            <!-- Firstname field -->
            <ion-row
                class="ion-align-items-center pl-4 ion-justify-content-center ion-margin-bottom border-2 border-solid has-border-blue-misty"
            >
                <ion-input
                    class="size-16 is-grey-fade"
                    formControlName="firstname"
                    [readonly]="readonly"
                    placeholder="Prénom"
                    type="text"
                >
                    <ion-icon
                        name="person-outline"
                        color="dove-grey"
                        class="ion-margin"
                    ></ion-icon>
                </ion-input>
            </ion-row>

            <!-- Lastname required -->
            <div
                *ngIf="submit && f.lastname.errors && f.lastname.errors.required"
                class="size-12 ion-text-left ml-34 mt-5"
            >
                <ion-text color="danger">Le nom est obligatoire</ion-text>
            </div>

            <!-- Lastname field -->
            <ion-row
                class="ion-align-items-center pl-4 ion-margin-bottom ion-justify-content-center border-2 border-solid has-border-blue-misty"
            >
                <ion-input
                    class="size-16 is-grey-fade"
                    formControlName="lastname"
                    [readonly]="readonly"
                    placeholder="Nom"
                    type="text"
                >
                    <ion-icon
                        name="person-outline"
                        color="dove-grey"
                        class="ion-margin"
                    ></ion-icon>
                </ion-input>
            </ion-row>

            <!-- Phone errors -->
            <div
                *ngIf="submit && f.phone.errors"
                class="size-12 ion-text-left ml-34 mt-5"
            >
                <!-- Phone required -->
                <ion-text *ngIf="f.phone.errors.required" color="danger"
                    >Le numéro de téléphone est obligatoire</ion-text
                >

                <!-- Phone length -->
                <div
                    *ngIf="f.phone.hasError('minlength') || f.phone.hasError('maxlength')"
                >
                    <ion-text color="danger"
                        >La longueur du numéro de téléphone doit être compris
                        entre 8 et 16 caractères</ion-text
                    >
                </div>
            </div>

            <!-- Phone field -->
            <ion-row
                class="ion-align-items-center is-grey-fade pl-4 ion-margin-bottom ion-justify-content-center mt-15 has-border-2 border-solid has-border-blue-misty"
                [ngClass]="{ 'border-1 has-border-danger': submit && f.phone.errors, 'border-2 has-border-blue-misty':!submit || f.phone.valid }"
            >
                <!-- Phone icon -->
                <ion-col size="auto" class="ion-no-padding">
                    <ion-icon
                        name="call-outline"
                        color="dove-grey"
                        class="ion-margin"
                    ></ion-icon>
                </ion-col>
                <!-- Phone indicator -->
                <ion-col size="auto" class="ion-no-padding">
                    <app-phone-indicator
                        [disabled]="readonly"
                    ></app-phone-indicator>
                </ion-col>
                <!-- Phone input -->
                <ion-col class="ion-no-padding">
                    <ion-input
                        class="pl-1 size-16"
                        [readonly]="readonly"
                        formControlName="phone"
                        type="tel"
                        placeholder="Numéro de téléphone"
                        (ionBlur)="check()"
                        (keypress)="keyPress($event)"
                    >
                    </ion-input>
                </ion-col>
            </ion-row>

            <!-- Country -->
            <ion-row
                class="ion-align-items-center ion-margin-bottom pl-9 ion-justify-content-center border-2 border-solid"
                [ngClass]="{ 'has-border-danger': !userCity?.country?.name, 'has-border-blue-misty':userCity?.country?.name }"
            >
                <ion-col size="auto">
                    <ion-icon
                        name="earth-outline"
                        color="dove-grey"
                        class="ion-margin-start ion-no-margin ml-10"
                    >
                    </ion-icon>
                </ion-col>
                <ion-col>
                    <ion-input
                        class="is-grey-fade"
                        *ngIf="readonly"
                        placeholder="Entrer votre"
                        [value]="userCity?.country?.name"
                        disabled
                    >
                    </ion-input>
                    <div [ngClass]="{ 'hidden': readonly }">
                        <app-ng-autocomplete
                            [data]="countries"
                            [searchKeyword]="search"
                            placeholder="Entrer votre pays"
                            [initialValue]="userCity?.country?.name"
                            historyHeading="Récemment sélectionné"
                            (selected)="selectCountryEvent($event)"
                            historyIdentifier="countries"
                            [itemTemplate]="itemTemplate"
                            [notFoundTemplate]="notFoundTemplate"
                            class="py-3"
                        >
                        </app-ng-autocomplete>

                        <ng-template #itemTemplate let-item>
                            <div class="m-10">
                                <ion-text
                                    color="grey-fade"
                                    [innerHTML]="item.name"
                                >
                                </ion-text>
                            </div>
                        </ng-template>

                        <ng-template #notFoundTemplate let-notFound>
                            <ion-text color="grey-fade">Non trouvé</ion-text>
                        </ng-template>
                    </div>
                </ion-col>
            </ion-row>

            <!-- Town -->
            <ion-row
                class="ion-align-items-center pl-9 ion-justify-content-center border-2 border-solid radius-tl-5 radius-tr-5"
                [ngClass]="{ 'has-border-danger': !userCity?.name,'has-border-blue-misty':userCity?.name}"
            >
                <ion-col size="auto">
                    <ion-icon
                        name="business-outline"
                        color="dove-grey"
                        class="ml-10"
                    >
                    </ion-icon>
                </ion-col>
                <ion-col>
                    <ion-input
                        class="is-grey-fade"
                        *ngIf="readonly"
                        placeholder="Entrer votre ville"
                        [value]="userCity?.name"
                        disabled
                    >
                    </ion-input>
                    <div [ngClass]="{ 'hidden': readonly }">
                        <app-ng-autocomplete
                            [data]="cities"
                            [searchKeyword]="search"
                            placeholder="Entrer votre ville"
                            [initialValue]="userCity"
                            [disabled]="readonly"
                            historyHeading="Récemment sélectionné"
                            (selected)="selectCityEvent($event)"
                            (inputCleared)="removeCity()"
                            historyIdentifier="cities"
                            [itemTemplate]="cityTemplate"
                            [notFoundTemplate]="notFoundCityTemplate"
                            class="py-3 is-grey-fade"
                        >
                        </app-ng-autocomplete>

                        <ng-template #cityTemplate let-item>
                            <div class="m-10">
                                <ion-text
                                    color="grey-fade"
                                    [innerHTML]="item.name"
                                ></ion-text>
                            </div>
                        </ng-template>

                        <ng-template #notFoundCityTemplate let-notFound>
                            <ion-text color="grey-fade">Non trouvé</ion-text>
                        </ng-template>
                    </div>
                </ion-col>
            </ion-row>

            <!-- Blood group -->
            <ion-row
                class="ion-align-items-center inputStyle mt-15 pl-4"
                [ngClass]="{ 'border-1 border-solid has-border-danger': !f.groupeSanguin.value, 'border-2 border-solid has-border-blue-misty':f.groupeSanguin.value }"
            >
                <ion-col
                    size="auto"
                    class="ion-margin-horizontal ion-no-padding"
                >
                    <ion-icon name="water-outline" color="dove-grey"></ion-icon>
                </ion-col>
                <ion-col
                    class="border-solid border-1 has-border-blue-misty radius-tl-5 radius-tr-5 ion-padding-horizontal"
                >
                    <ion-select
                        class="pl-1 is-grey-fade profile__option"
                        formControlName="groupeSanguin"
                        [disabled]="readonly"
                        placeholder="Groupe sanguin"
                        okText="OK"
                        cancelText="Quitter"
                    >
                        <ion-select-option value="A_PLUS">A+</ion-select-option>
                        <ion-select-option value="B_PLUS">B+</ion-select-option>
                        <ion-select-option value="AB_PLUS"
                            >AB+</ion-select-option
                        >
                        <ion-select-option value="O_PLUS">O+</ion-select-option>
                        <ion-select-option value="A_MOINS"
                            >A-</ion-select-option
                        >
                        <ion-select-option value="B_MOINS"
                            >B-</ion-select-option
                        >
                        <ion-select-option value="AB_MOINS"
                            >AB-</ion-select-option
                        >
                        <ion-select-option value="O_MOINS"
                            >0-</ion-select-option
                        >
                    </ion-select>
                </ion-col>
            </ion-row>

            <!-- Secteur Activite -->
            <ion-row
                class="ion-align-items-center inputStyle mt-15 pl-4"
                [ngClass]="{ 'border-1 border-solid has-border-danger': !f.secteurActivite.value, 'border-2 border-solid has-border-blue-misty':f.secteurActivite.value }"
            >
                <ion-col size="auto" class="ion-no-padding ion-margin">
                    <ion-icon
                        name="bag-handle-outline"
                        color="dove-grey"
                    ></ion-icon>
                </ion-col>

                <ion-col
                    class="border-solid border-1 has-border-blue-misty radius-tl-5 radius-tr-5 ion-padding-horizontal"
                >
                    <ion-select
                        class="pl-1 is-grey-fade profile__option"
                        [ngClass]="{ 'border-1 border-solid has-border-danger': submit && f.secteurActivite.errors }"
                        [disabled]="readonly"
                        formControlName="secteurActivite"
                        placeholder="Secteur d'Activité"
                        okText="OK"
                        cancelText="Quitter"
                    >
                        <ion-select-option value="LIBERAL"
                            >LIBERAL</ion-select-option
                        >
                        <ion-select-option value="FONCTION_PUBLIQUE"
                            >FONCTION PUBLIQUE</ion-select-option
                        >
                        <ion-select-option value="INFORMEL"
                            >INFORMEL</ion-select-option
                        >
                        <ion-select-option value="ELEVE"
                            >ELEVE</ion-select-option
                        >
                        <ion-select-option value="ETUDIANT"
                            >ETUDIANT</ion-select-option
                        >
                        <ion-select-option value="RETRAITE"
                            >RETRAITE</ion-select-option
                        >
                    </ion-select>
                </ion-col>
            </ion-row>

            <!-- Antecedents -->
            <ion-row
                class="mt-15 height-157 radius-5 pl-20 border-1 border-solid has-border-blue-misty radius-5"
            >
                <ion-col size="auto">
                    <ion-icon
                        name="folder-open-outline"
                        color="dove-grey"
                        class="mt-12"
                    ></ion-icon>
                </ion-col>
                <ion-col>
                    <ion-textarea
                        class="mt-0 pt-0 px-12 is-grey-fade"
                        placeholder="Antecedant"
                        [readonly]="readonly"
                        formControlName="antecedents"
                        rows="6"
                        [ngClass]="{ 'border-1 border-solid has-border-danger':
                        submit && f.antecedents.errors }"
                    >
                    </ion-textarea>
                </ion-col>
            </ion-row>
        </form>

        <!-- Error -->
        <div *ngIf="error && !submit" class="size-12 ion-text-left ml-34 mt-5">
            <ion-text color="danger">{{error}}</ion-text>
        </div>
    </ion-grid>
</ion-content>
<ion-footer class="ion-no-border">
    <ion-row class="ion-justify-content-center ion-margin-bottom">
        <ion-col size="10">
            <app-button
                [title]="readonly ? 'Modifier' : 'Valider'"
                [loading]="loading"
                class="button--radius-10 size-16 is-white-dove"
                size="large"
                expand="full"
                shape="round"
                (click)="onSubmit()"
                (keyPress)="onSubmit()"
            ></app-button>
        </ion-col>
    </ion-row>
</ion-footer>
